// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBVTEMM_REAPER_H
#define _LIBVTEMM_REAPER_H

#include <libvtemmconfig.h>

#ifndef LIBVTEMM_DISABLE_DEPRECATED


#include <glibmm.h>

/* reaper.h
 *
 * Copyright (C) 2008 libvtemm Development Team
 *
 * This file is part of libvtemm.
 *
 * libvtemm is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libvtemm is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser Public License for more details.
 *
 * You should have received a copy of the GNU Lesser Public License
 * along with libvtemm.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glibmm.h>

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _VteReaper VteReaper;
typedef struct _VteReaperClass VteReaperClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Vte
{ class Reaper_Class; } // namespace Vte

} // namespace Gnome
namespace Gnome
{

namespace Vte
{

/** Reaper - A singleton object which catches <tt>SIGCHLD</tt> signals and converts them into GObject-style "child-exited" signals.
 */

class Reaper : public Glib::Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Reaper CppObjectType;
  typedef Reaper_Class CppClassType;
  typedef VteReaper BaseObjectType;
  typedef VteReaperClass BaseClassType;

private:  friend class Reaper_Class;
  static CppClassType reaper_class_;

private:
  // noncopyable
  Reaper(const Reaper&);
  Reaper& operator=(const Reaper&);

protected:
  explicit Reaper(const Glib::ConstructParams& construct_params);
  explicit Reaper(VteReaper* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Reaper();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  VteReaper*       gobj()       { return reinterpret_cast<VteReaper*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const VteReaper* gobj() const { return reinterpret_cast<VteReaper*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  VteReaper* gobj_copy();

private:

  
private:
  Reaper();
public:
  
  /** Finds the address of the global Vte::Reaper object, creating the object if
   * necessary.
   * @return The global Vte::Reaper object, which should not be unreffed.
   */
  static const Glib::RefPtr<Reaper> get();
  
  /** Ensures that child-exited signals will be emitted when @a pid exits.  This is
   * necessary for correct operation when running with glib versions >= 2.4.
   * @param pid The ID of a child process which will be monitored.
   * @return The new source ID
   * 
   * Since 0.11.11.
   */
  static int add_child(Glib::Pid pid);
  
  /**
   * @par Prototype:
   * <tt>void on_my_%child_exited(int pid, int status)</tt>
   */

  Glib::SignalProxy2< void,int,int > signal_child_exited();


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace Vte

} // namespace Gnome


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gnome::Vte::Reaper
   */
  Glib::RefPtr<Gnome::Vte::Reaper> wrap(VteReaper* object, bool take_copy = false);
}


#endif // LIBVTEMM_DISABLE_DEPRECATED


#endif /* _LIBVTEMM_REAPER_H */

