// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBVTEMM_TERMINALACCESSIBLE_H
#define _LIBVTEMM_TERMINALACCESSIBLE_H


#include <glibmm.h>

/* terminalaccessible.h
 *
 * Copyright (C) 2008 libvtemm Development Team
 *
 * This file is part of libvtemm.
 *
 * libvtemm is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libvtemm is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser Public License for more details.
 *
 * You should have received a copy of the GNU Lesser Public License
 * along with libvtemm.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <atkmm.h>
#include <libvtemm/terminal.h>

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _VteTerminalAccessible VteTerminalAccessible;
typedef struct _VteTerminalAccessibleClass VteTerminalAccessibleClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Vte
{ class TerminalAccessible_Class; } // namespace Vte

} // namespace Gnome
namespace Gnome
{

namespace Vte
{
/** TerminalAccessible - Accessibility peer of #Gnome::Vte::Terminal.
 */

class TerminalAccessible
: public Atk::Object,
  public Atk::Component,
  public Atk::Action,
  public Atk::Text
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef TerminalAccessible CppObjectType;
  typedef TerminalAccessible_Class CppClassType;
  typedef VteTerminalAccessible BaseObjectType;
  typedef VteTerminalAccessibleClass BaseClassType;

private:  friend class TerminalAccessible_Class;
  static CppClassType terminalaccessible_class_;

private:
  // noncopyable
  TerminalAccessible(const TerminalAccessible&);
  TerminalAccessible& operator=(const TerminalAccessible&);

protected:
  explicit TerminalAccessible(const Glib::ConstructParams& construct_params);
  explicit TerminalAccessible(VteTerminalAccessible* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~TerminalAccessible();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  VteTerminalAccessible*       gobj()       { return reinterpret_cast<VteTerminalAccessible*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const VteTerminalAccessible* gobj() const { return reinterpret_cast<VteTerminalAccessible*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  VteTerminalAccessible* gobj_copy();

private:

  
protected:
  explicit TerminalAccessible(const Terminal& terminal);
public:
/** Creates a new accessibility peer for the terminal widget.
 * @param terminal #Gnome::Vte::Terminal widget for which accessibility peer should be created.
 * @return The new #TerminalAccessible
 */
  
  static Glib::RefPtr<TerminalAccessible> create(const Terminal& terminal);


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace Vte

} // namespace Gnome


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gnome::Vte::TerminalAccessible
   */
  Glib::RefPtr<Gnome::Vte::TerminalAccessible> wrap(VteTerminalAccessible* object, bool take_copy = false);
}


#endif /* _LIBVTEMM_TERMINALACCESSIBLE_H */

